/**
 * v1.2 - Copyright 2015 Madden Media - All rights reserved.
 *
 * A set of parallax design functionality.
 */
!function(a){"use strict";a.fn.parallaxBG=function(b){var c=a(window).height(),d=0,e=a(window).scrollTop(),f=0,g=0,h=a.extend({adjustX:0,adjustY:0,bgXOffset:0,bgYOffset:0,bgXPosition:"100%",bgYPosition:"100%"},b);return this.each(function(){var b=a(this);a(window).scroll(function(){var i=h.bgXAdjust,j=b.css("backgroundPosition").split(" ");parseInt(j[0]);if(e=a(window).scrollTop(),f=b.offset().top,g=b.outerHeight(),e<d&&0!=i&&(i*=-1),d=e,!(f+g<=e||f>=e+c)){var l=0==h.adjustX?h.bgXPosition:Math.round((f-e)*h.adjustX)+0+h.bgXOffset+"px",m=0==h.adjustY?h.bgYPosition:Math.round((f-e)*h.adjustY)+0+h.bgYOffset+"px";b.css("background-position",l+" "+m)}})})},a.fn.parallaxLockElement=function(b){var c=!1,d=a.extend({parentEl:"",offsetTop:0,additionalCSS:void 0,onLock:void 0,onRelease:void 0},b);return this.each(function(){var b=a(this),e=a(d.parentEl);a(window).scroll(function(){var f=parseInt(e.offset().top-a(window).scrollTop()-d.offsetTop),g=e.offset().top+e.outerHeight(),i=(parseInt(b.outerHeight()),e.offset().top+e.outerHeight()-(b.offset().top+b.outerHeight()));f<=0?g+i<=a(window).scrollTop()+a(window).innerHeight()?c&&(c=!1,b.css({position:"absolute",top:"inherit",bottom:i+"px"}),"function"==typeof d.onRelease&&d.onRelease(this)):(b.css({position:"fixed",top:d.offsetTop+"px",bottom:"auto"}),"function"==typeof d.onLock&&d.onLock(this),c=!0):(b.css({position:"relative",top:"auto"}),"function"==typeof d.onRelease&&d.onRelease(this),c=!1),void 0!=d.additionalCSS&&b.css(d.additionalCSS)})})},a.fn.parallaxAnimateElement=function(b){var c=new Array,d=0,e=0,f=!1,g=a.extend({frames:1,elementClass:"floatingElement",elementFrameClassRoot:"frame",startOffset:null,endOffset:null,showWhenCentered:!1,centerOffsetAnimationRange:null,lock:!1,parentEl:"",offsetTop:0,additionalCSS:void 0,onLock:void 0,onRelease:void 0},b);g.lock?a(this).parallaxLockElement({parentEl:g.parentEl,offsetTop:g.offsetTop,additionalCSS:g.additionalCSS,onLock:g.onLock,onRelease:g.onRelease}):f=!0;var h=parseInt(a(this).parent().height());if(g.showWhenCentered)null==g.centerOffsetAnimationRange?g.centerOffsetAnimationRange=1:g.centerOffsetAnimationRange.indexOf("%")!=-1?g.centerOffsetAnimationRange=parseInt(g.centerOffsetAnimationRange)/100:g.centerOffsetAnimationRange=1;else{if(null!=g.startOffset)if(g.startOffset.indexOf("%")!=-1){var i=parseInt(g.startOffset)/100;d=Math.floor(h*i)}else{var i=parseInt(g.startOffset);d=i}if(null!=g.endOffset)if(g.endOffset.indexOf("%")!=-1){var i=parseInt(g.endOffset)/100;e=Math.floor(h-h*i)}else{var i=parseInt(g.endOffset);e=i}0==d&&0==e||(h=h-e-d);for(var j=h/g.frames,k=1;k<=g.frames;k++)c.push(Math.floor(d+j*k));f&&void 0!=g.additionalCSS&&a(this).css(g.additionalCSS)}return this.each(function(){var b=a(this),d=c.length,e=g.showWhenCentered?a(this).height()*g.centerOffsetAnimationRange:a(this).height();a(window).scroll(function(){var f=b.offset().top,h=!(f+b.outerHeight()<=a(window).scrollTop()||f>=a(window).scrollTop()+a(window).height());if(h){if(g.showWhenCentered){var i=parseInt(b.offset().top-a(window).scrollTop()),j=parseInt(i+e/2),k=parseInt(a(window).innerHeight()/2),l=parseInt(j-e),m=parseInt(j+e);if(k<l)d=1;else if(k>=l&&k<=m){var n=Math.max(0,Math.min(1,1-(l+(j-k))/j));d=Math.ceil(g.frames*n)}else d=g.frames}else for(var o=parseInt(b.parent().offset().top-a(window).scrollTop()),p=o*-1+e/2,q=0;q<c.length;q++)if(p<=c[q]){d=q+1;break}b.attr("class",g.elementClass+" "+g.elementFrameClassRoot+d)}})})}}(jQuery);

var _setChapterLinkCallback,_chapterSetCompleteCallback,_stickyTopBarProgressBarEl,_stickyTopBarHeight=0,_stickyTopBarOffset=0,_chapterTops=new Array,_onChapter=0,_stickyTopBarEl="#topBar",_mobileMenuEl="#mobileMenu",_socialMenuTriggerEl="#socialLinksTrigger",_topAndMobileMenuControl="#controlsTrigger",_chapterEl=".chapter",_chapterLinkEl=".chapterLink",_chapterElPrefix="#c",_multiSizeImageEl=".multiSize",_readMoreEl=void 0,_relatedLinkEl="#alsoLikeLinkWrap",_lazyLoadDataName="[data-load-type]",DEFAULT_SM_TEST_EL="#isSmall",DEFAULT_MD_TEST_EL="#isMedium",DEFAULT_LG_TEST_EL="#isLarge",IS_RESPONSIVE=document.addEventListener,_isSmall=!1,_isMedium=!1,_isLarge=!1,_lazyLoadObject=null;frameworksOnReady=function(e,t,r){initViewTypes(),initLayout(e,t,r)},frameworksOnScroll=function(){adjustScrollProgress()},frameworksOnTouchMove=function(){adjustScrollProgress()},frameworksOnResize=function(){initViewTypes(),adjustLayoutAfterResize()},initViewTypes=function(){_isSmall=0!=jQuery(DEFAULT_SM_TEST_EL).length&&"none"!=jQuery(DEFAULT_SM_TEST_EL).css("float"),_isMedium=0!=jQuery(DEFAULT_MD_TEST_EL).length&&"none"!=jQuery(DEFAULT_MD_TEST_EL).css("float"),_isLarge=0!=jQuery(DEFAULT_LG_TEST_EL).length&&"none"!=jQuery(DEFAULT_LG_TEST_EL).css("float")},initLayout=function(e,t,r){if(null!=e&&(_setChapterLinkCallback=e.setChapterLinkCallback||_setChapterLinkCallback,_chapterSetCompleteCallback=e.chapterSetCompleteCallback||_chapterSetCompleteCallback),null!=t&&(_stickyTopBarEl=t.topBar||_stickyTopBarEl,_mobileMenuEl=t.mobileMenuEl||_mobileMenuEl,_socialMenuTriggerEl=t.socialMenuTriggerEl||_socialMenuTriggerEl,_topAndMobileMenuControl=t.topAndMobileMenuControl||_topAndMobileMenuControl,_chapterEl=t.chapterEl||_chapterEl,_chapterLinkEl=t.chapterLinkEl||_chapterLinkEl,_chapterElPrefix=t.chapterElPrefix||_chapterElPrefix,_multiSizeImageEl=t.multiSizeImageEl||_multiSizeImageEl,_readMoreEl=t.readMoreEl||_readMoreEl,_relatedLinkEl=t.relatedLinkEl||_relatedLinkEl,_lazyLoadDataName=t.lazyLoadDataName||_lazyLoadDataName),jQuery.getScript("https://www.maddencdn.com/global/scripts/layout/madden-lazy-load-jquery-v1.0-min.js").done(function(e,t){_lazyLoadObject=jQuery("*[data-load-type]").lazyLoad()}).fail(function(e,t,r){console.log("NOTICE lazy load did not load.")}),jQuery(_mobileMenuEl).length){var o=jQuery(_mobileMenuEl),a=o.data("chapters"),n=o.data("top-link"),i=o.data("close-trigger");try{jQuery(i).click(function(){toggleMobileMenu(_mobileMenuEl,_topAndMobileMenuControl)}),jQuery(n).click(function(){toTop(),toggleMobileMenu(_mobileMenuEl,_topAndMobileMenuControl)}),jQuery(a).children("div").each(function(t){jQuery(this).click(function(){toggleMobileMenu(_mobileMenuEl,_topAndMobileMenuControl);var e=jQuery(this).data("chapter");void 0===e?goToChapter(t+1):goToChapter(parseInt(e))})})}catch(e){console.log(e)}}if(jQuery(_socialMenuTriggerEl).length){var l=jQuery(_socialMenuTriggerEl),s=l.data("social-links"),c=l.data("social-links-class-off"),u=l.data("social-links-class-on"),p=l.data("trigger-class-off"),d=l.data("trigger-class-on");try{var h=jQuery(s);getIsDesktop()?h.on("mouseenter",function(e){l.attr("class",d)}).on("mouseleave",function(e){l.attr("class",p)}):jQuery(document).on("touchstart",s,function(e){h.attr("class",u),l.attr("class",d)}).on("touchend",function(){h.attr("class",c),l.attr("class",p)}).on("touchcancel",function(){h.attr("class",c),l.attr("class",p)})}catch(e){console.log(e)}}jQuery(".socialShare").each(function(){var e=jQuery(this).attr("class"),t="#",r=!1;if(-1!=e.indexOf("pinterest")){var o=jQuery(this).data("ogimage");t=buildSocialShareLink("PINTEREST",o)}else-1!=e.indexOf("twitter")?t=buildSocialShareLink("TWITTER",null):-1!=e.indexOf("facebook")&&(r=!0,t=buildSocialShareLink("FACEBOOK",null));null==t?jQuery(this).attr("href","javascript:alert('Sharing this site is not currently available.')"):r?(jQuery(this).attr("href","#"),jQuery(this).attr("onclick",t)):jQuery(this).attr("href",t)}),jQuery(_stickyTopBarEl).length&&(_stickyTopBarHeight=jQuery(_stickyTopBarEl).height(),null!=jQuery(_stickyTopBarEl).data("offset-el")&&0!=jQuery(jQuery(_stickyTopBarEl).data("offset-el")).length&&(_stickyTopBarOffset=jQuery(jQuery(_stickyTopBarEl).data("offset-el")).offset().top),null!=jQuery(_stickyTopBarEl).data("progress-bar-el")&&0!=jQuery(jQuery(_stickyTopBarEl).data("progress-bar-el")).length&&(_stickyTopBarProgressBarEl=jQuery(_stickyTopBarEl).data("progress-bar-el"))),null!=_readMoreEl&&(jQuery.isArray(_readMoreEl)||(_readMoreEl=[_readMoreEl]),jQuery.each(_readMoreEl,function(e,t){jQuery(t).click(function(){var e=0;null!=jQuery(t).data("offset-el")&&0!=jQuery(jQuery(t).data("offset-el")).length&&(e=jQuery(jQuery(t).data("offset-el")).offset().top),jQuery("html, body").animate({scrollTop:e-_stickyTopBarHeight},300)})})),r&&initChapterTops(!0),jQuery(_chapterLinkEl).click(function(){var e=jQuery(this).data("chapter");if(void 0!==e)goToChapter(parseInt(e));else{jQuery(this.hash);goToChapter(this.hash.substr(1))}return!1})},initChapterTops=function(e){var t=new Array;jQuery(_chapterEl).each(function(e){t[e]=Math.floor(jQuery(this).offset().top-_stickyTopBarHeight)}),_chapterTops=t,e&&adjustScrollProgress()},buildSocialShareLink=function(e,t){var r,o="",a="",n=encodeURIComponent(document.title),i=encodeURIComponent(t);if("file:"==location.protocol){var l=jQuery("body").data("online-url"),s=jQuery("link[rel='canonical']").href;if(void 0!==l?a=l:void 0!==s&&(a=s),""==a)return null}else""==a&&(a=[location.protocol,"//",location.host,location.pathname].join(""));switch(r=encodeURIComponent(a),e){case"FACEBOOK":o="window.open('https://www.facebook.com/sharer/sharer.php?u="+r+"','facebook-share-dialog', 'width=626,height=436'); return false;";break;case"PINTEREST":o="https://www.pinterest.com/pin/create/button/?url="+r+"&media="+i+"&description="+n;break;case"TWITTER":o="https://twitter.com/intent/tweet?text="+n+"%3A%20"+r+"&amp;source=webclient"}return o},buildRelatedLinks=function(e){for(var t=jQuery(_relatedLinkEl),r=0;r<e.length;r++){var o=r+1,a="<div class='linkWrapper'><a href='"+e[r].link+"' target='_blank'><div class='rLink rLink"+o+"'><div id='linkWrapper"+o+"' class='linkTitleWrapper'><div class='linkTitle'>"+e[r].title+"</div></div></div></a></div>";t.append(a)}},unFixBGImagesForIPads=function(e){e=void 0===e?".chapterImage":e,getIsLarge()&&getIsIPad()&&$(e).css("background-attachment","scroll")},getLazyLoadPluginObject=function(){return _lazyLoadObject},getCurrentChapter=function(){return _onChapter},getVisibleViewport=function(e){return e?window.innerHeight-_stickyTopBarHeight+"px":parseInt(window.innerHeight-_stickyTopBarHeight)},getViewportOffset=function(e,t){return t?jQuery(e).offset().top-jQuery(window).scrollTop()-_stickyTopBarHeight+"px":parseInt(jQuery(e).offset().top-jQuery(window).scrollTop()-_stickyTopBarHeight)},getItemInViewport=function(e){var t=jQuery(e).offset().top;return!(t+jQuery(e).outerHeight()<=jQuery(window).scrollTop()||t>=jQuery(window).scrollTop()+jQuery(window).height())},getItemInViewportCenter=function(e,t){var r=jQuery(e).offset().top,o=jQuery(window).height()/2;return t=t||0,!(r>=jQuery(window).scrollTop()+o+t||r<=jQuery(window).scrollTop()+o-t)},getStickyTopBarHeight=function(){return _stickyTopBarHeight},getIsSmall=function(){return _isSmall},getIsMedium=function(){return _isMedium},getIsLarge=function(){return _isLarge},getIsMobile=function(){return"undefined"!=typeof console&&console.log("%c NOTICE getIsMobile()) deprecated - use getIsSmall()","background:orange; color:black"),_isSmall},getIsTablet=function(){return"undefined"!=typeof console&&console.log("%c NOTICE getIsTablet()) deprecated - use getIsMedium()","background:orange; color:black"),_isMedium},getDoParallax=function(){return"undefined"!=typeof console&&console.log("%c NOTICE getDoParallax()) deprecated - use getIsLarge()","background:orange; color:black"),_isLarge},getIsDesktop=function(){return!/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)},getIsIPad=function(){return navigator.userAgent.match(/iPad;.*CPU.*OS/i)},getIsNewerIPad=function(){return!!getIsIPad()&&1!=window.devicePixelRatio},getIsResponsive=function(){return IS_RESPONSIVE},adjustLayoutAfterResize=function(){initChapterTops(!0)},adjustChapterLinksArtHeight=function(e,t){jQuery(e).css("height",jQuery(t).outerHeight())},adjustSizeToParentAndViewport=function(e,t){jQuery(e).css("height",getVisibleViewport(!0)),jQuery(e).css("width",jQuery(t).width())},adjustSizeHeightToParent=function(e,t){var r=jQuery(t).height();jQuery(e).css("height",r+"px")},equalizeElementHeightsToTallest=function(e){for(var t=0,r=0;r<e.length;r++){var o=jQuery(e[r]).height();null!=o&&(t=t<o?o:t)}for(r=0;r<e.length;r++)jQuery(e[r]).css("height",t+"px")},adjustScrollProgress=function(){if(0!=jQuery(_stickyTopBarProgressBarEl).length){var e,t=-1,r=jQuery(document).height()-jQuery("body").height()-_stickyTopBarOffset;e=Math.round((jQuery(document).scrollTop()-_stickyTopBarOffset)/r*100),jQuery(_stickyTopBarProgressBarEl).css("width",e+"%");for(var o=_chapterTops.length-1;0<=o;o--)if(jQuery(document).scrollTop()>=_chapterTops[o]){t=o+1;break}return-1!=t&&adjustChapterLinks(t),t}},adjustChapterLinks=function(e){jQuery(_chapterLinkEl).each(function(){jQuery(this).attr("href")!="#"+e?"function"==typeof _setChapterLinkCallback&&_setChapterLinkCallback(this,!1):("function"==typeof _setChapterLinkCallback&&_setChapterLinkCallback(this,!0),_onChapter=e)})},adjustMultiSizedImages=function(){"undefined"!=typeof console&&console.log("%c NOTICE adjustMultiSizedImages()) deprecated - lazy load is automatically managed","background:orange; color:black")},toTop=function(){jQuery("html, body").animate({scrollTop:0},600)},runTopMenuControl=function(){getIsSmall()?toggleMobileMenu(_mobileMenuEl,_topAndMobileMenuControl):toTop()},toggleMobileMenu=function(e,t){getIsSmall()&&(jQuery(e).toggle("fast"),jQuery(t).toggle("fast"))},goToChapter=function(e){var t=jQuery(_chapterElPrefix+e).offset().top-_stickyTopBarHeight+1,r=e<_onChapter?_onChapter-e:e-_onChapter,o=Math.floor(1e3/(_chapterTops.length-(_chapterTops.length-r)));jQuery("html, body").animate({scrollTop:t},o,function(){adjustChapterLinks(e),"function"==typeof _chapterSetCompleteCallback&&_chapterSetCompleteCallback(e)}),_onChapter=e},animateOverflowContent=function(e,t,r,o,a){if(a==_onChapter){var n=jQuery(e).css("background-position").split(" "),i=isNaN(t)?t:t+parseInt(n[0])+"px",l=isNaN(r)?r:r+parseInt(n[1])+"px";jQuery(e).css({"background-position":i+" "+l})}window.setTimeout(function(){animateOverflowContent(e,t,r,o,a)},o)},cycleImages=function(e,t){var r=jQuery(e+" .active"),o=0<r.next().length?r.next():jQuery(e+" img:first");o.css("z-index",2),r.fadeOut(t,function(){r.css("z-index",1).show().removeClass("active"),o.css("z-index",3).addClass("active")})},getScrollBarWidth=function(){return window.innerWidth-document.documentElement.clientWidth};

/**
 * v1.0 - Copyright 2014 Madden Media - All rights reserved.
 *
 * Content-specific layout functionality. These functions
 *	make many assumptions about content contained in the page.
 *
 * NOTE: Assumes that madden-content-frameworks-v1.0.js has been loaded and
 *	that the initial view types (mobile, tablet, etc.) have been defined.
 */

// mobile can call resize during scroll - we can cache width
//	and check if an actual resize happens
var _winWidth = 0;

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// STOCK EVENT FUNCTIONS
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////



//
// Called on document ready
//
contentOnReady = function () {

	// set the window width
	_winWidth = $(window).width();
	
	// parallax effects
	if ( (getIsLarge()) || (getIsNewerIPad()) ) {
		var adjust = (getIsNewerIPad()) ? -.12 : .12;
		$("#ci0").parallaxBG({ adjustY: adjust, bgXPosition: 'center' });	
		if (getIsNewerIPad()) {
			$("#ci0").parallaxBG({ adjustY: adjust, bgXPosition: 'center' });	
		}
	}
	
	// Recommended Reads links
	var relatedLinks = [
		{ "title": "Adventure Awaits", "link": "https://www.grandcanyonwest.com/grand-canyon-west.htm" },
		{ "title": "GRAND CANYON LODGING", "link": "https://www.grandcanyonwest.com/hualapai-lodge-and-route-66.htm" },
		{ "title": "WALAPAI MARKET", "link": "https://www.grandcanyonwest.com/walapai-market.htm" }
	];

	// footer links
	buildRelatedLinks(relatedLinks);
	
	equalizeElementHeightsToTallest($(".linkTitleWrapper"));
	
	// End Recommended Reads links
	
	// ipad pro will use large size, but needs backgrounds set to scroll, not fixed
	unFixBGImagesForIPads();
	
	customAdjustLayout(true);
	
	// add the complete class to the loader
	$('#loading').addClass('complete');
}
  
//
// Called on document scroll
//
contentOnScroll = function () {	
	customAdjustLayout();		
}

//
// Called on a touch move on mobile
//
contentOnTouchMove = function () { }

//
// Called on document resize
//
contentOnResize = function () { 
	customAdjustLayout();
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// CUSTOM FUNCTIONS
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

//
// The frameworks was given this function to handle setting chapter buttons 
//	when the chapter is set
//
// chapterEl: The chapter link DOM element 
// on: Is it being turned on? (true|false)
//
customChapterLinkAdjust = function (chapterEl, on) {
	$(chapterEl).attr("class", ((on) ? "navLink chapterLink noGA on" : "navLink chapterLink noGA"));
}

//
// Adjust this specific layout after a load or resize event
//
// isLoad: Is this being called by a load or resize event?
//
customAdjustLayout = function (isLoad) {
		
	var localNotJustTouchScroll = isLoad;

	equalizeElementHeightsToTallest($(".linkTitleWrapper"));
	
	// is it really a resize?
	if ($(window).width() != _winWidth) {
    	// yes
		localNotJustTouchScroll = true;
		_winWidth = $(window).width();
	}

}


